%{!?dist: %define dist .slc5}
Summary: lcm-profile - Local Configuration Manager default profile
Name: lcm-profile
Version: 1
Release: 20161110.1%{?dist}
BuildArch: noarch
Group: quattor/System
Vendor: CERN
License: GPL
Source0: %{name}-%{version}.tar.gz
Patch1: lcm-profile-1.nobusybox.patch

BuildRequires: net-tools
%if 0%{?rhel} < 7
BuildRequires: busybox
%endif
BuildRequires: bind-utils
BuildRequires: perl

BuildRoot: %{_tmppath}/%{name}-%{version}-root

Requires: ncm-afsclt >= 1.3.1
Requires: ncm-srvtab >= 2.0.1
Requires: ncm-krb5clt >= 2.1.6
Requires: ncm-sendmail >= 1.6.4
Requires: ncm-ntpd >= 1.0.9
Requires: ncm-chkconfig >= 1.1.1
Requires: ncm-ssh
Requires: ncm-ocsagent >= 0.0.3
%if 0%{?rhel} < 7
Requires: busybox
%endif
Requires: bind-utils
Requires: mozilla-prefs
Requires: lcm

%description

The lcm-profile supplies default profile for locally managed machines.
(used by lcm - the front end for invoking NCM configuration components
via ncm-ncd.)

Since these settings are highly CERN-specific, machines outside the
CERN domain will get a dummy file instead. External sites that really
want to use this mechanism should provide their own settings RPM.

%prep
%setup -q 
%if 0%{?rhel} >= 7
%patch1 -p1
%endif

%install
mkdir -p $RPM_BUILD_ROOT/usr/share/lcm/

install -m 444 profile_standalone_gpn_cern.xml $RPM_BUILD_ROOT/usr/share/lcm/
install -m 444 profile_standalone_tn_cern.xml $RPM_BUILD_ROOT/usr/share/lcm/
install -m 444 profile_standalone_atlas_cern.xml $RPM_BUILD_ROOT/usr/share/lcm/
install -m 444 profile_standalone_cms_cern.xml $RPM_BUILD_ROOT/usr/share/lcm/
install -m 444 profile_standalone_noncern.xml $RPM_BUILD_ROOT/usr/share/lcm/
touch $RPM_BUILD_ROOT/usr/share/lcm/profile_standalone.xml
chmod 444 $RPM_BUILD_ROOT/usr/share/lcm/profile_standalone.xml

%if "%{dist}" == ".slc5"
/usr/bin/perl -p -i -e 's/CERN-OCS-AGENT-TAG/SLC5/' $RPM_BUILD_ROOT/usr/share/lcm/profile*_cern.xml
# SLC5: no GSSAPITrustDNS option !
/usr/bin/perl -p -i -e 's#<string name="GSSAPITrustDNS">yes</string>#<!-- <string name="GSSAPITrustDNS">yes</string> -->#' $RPM_BUILD_ROOT/usr/share/lcm/profile*_cern.xml
%else
%if "%{dist}" == ".el7.cern"
/usr/bin/perl -p -i -e 's/CERN-OCS-AGENT-TAG/CC7/' $RPM_BUILD_ROOT/usr/share/lcm/profile*_cern.xml
%else
/usr/bin/perl -p -i -e 's/CERN-OCS-AGENT-TAG/SLC6/' $RPM_BUILD_ROOT/usr/share/lcm/profile*_cern.xml 
%endif
%endif

mkdir -p $RPM_BUILD_ROOT/%{_bindir}
install -m 755 cern_guess_network $RPM_BUILD_ROOT/%{_bindir}

%files
%defattr(-, root, root)
%{_bindir}/cern_guess_network
%config(noreplace)/usr/share/lcm/profile_standalone_gpn_cern.xml
%config(noreplace)/usr/share/lcm/profile_standalone_tn_cern.xml
%config(noreplace)/usr/share/lcm/profile_standalone_atlas_cern.xml
%config(noreplace)/usr/share/lcm/profile_standalone_cms_cern.xml
%config(noreplace)/usr/share/lcm/profile_standalone_noncern.xml
%ghost /usr/share/lcm/profile_standalone.xml
%doc README 

%post
if [ -x %{_bindir}/cern_guess_network ]; then
  cd /usr/share/lcm
  dns_domain=`%{_bindir}/cern_guess_network`
  case "$dns_domain" in
    atlas.cern.ch)
	ln -sf profile_standalone_atlas_cern.xml profile_standalone.xml
	;;
    cms.cern.ch)
        ln -sf profile_standalone_cms_cern.xml profile_standalone.xml
	;;
    tn.cern.ch)
	ln -sf profile_standalone_tn_cern.xml profile_standalone.xml
	;;
    dyndns.cern.ch)
	ln -sf profile_standalone_gpn_cern.xml profile_standalone.xml
	;;
    cern.ch)
	ln -sf profile_standalone_gpn_cern.xml profile_standalone.xml
	;;
    *)
	echo "LCM: applying dummy default configuration, non-CERN domain $dns_domain"
	ln -sf profile_standalone_noncern.xml profile_standalone.xml
        exit
	;;
    esac
  if [ -x /usr/sbin/lcm ]; then
    /usr/sbin/lcm --configure chkconfig || :
  fi

fi

if [ -x /usr/sbin/lcm ]; then
 ( /usr/sbin/lcm --update || : ) &
 pid=$!
 i=30  #timeout
 while [ "$i" -gt 0 ]; do
  sleep 1
  if ! kill -0 $pid >& /dev/null; then
  	# lcm finished in time
	break
  fi
  let i--
 done
 if [ "$i" = 0 ]; then
  echo "timeout for lcm, backgrounding it"
 fi
fi

%changelog
* Thu Nov 10 2016 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> 1-20161110
- dyndns.cern.ch handling for sendmail.

* Tue Aug 23 2016 Thomas Oulevey <thomas.oulevey@cern.ch> 1-20140602.2
- fix dyndns issue.

* Mon Jun 02 2014 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> 1-20140602.1
- last modification broke password auth on SLC5, adding use_shmem=sshd
  to fix it.

* Tue May 13 2014 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> 1-20140513.0
- modify sshd options to allow CERN account password change on expiry

* Tue Mar 12 2013 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> 1-20130312.0
- guess_domain.sh replaced by cern_guess_network: recognizes CERN GPN,TN,CMS 
  and ATLAS networks now.
- separate krb5.conf templates for above.

* Mon Feb 4 2013 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> 1-20130204.1.slc6
- Different krb5.conf for GPN, TN
- require up to date ncm-srvtab 

* Fri Mar 9 2012 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> 1-20111213.2.slc6
- added mozilla-prefs as deps.

* Tue Dec 13 2011 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> 1-20111213.1.slc6
- added dependencies on bind-utils and busybox for guess_domain.sh

* Mon Oct 31 2011 Jan van Eldik <Jan.van.Eldik@cern.ch> 1-20111031.slc6
- no longer pull cern-kerberos-migration

* Fri Apr 01 2011 Matthias Schroder <Matthias.Schroder@cern.ch> - 1-20110401.slc6
- Increase wait parameter for ocsinventory to stretch out reporting times

* Thu Mar 03 2011 Jan van Eldik <Jan.van.Eldik@cern.ch> 1-20110303.slc6
- change sshd loglevel to 'verbose' (as per security team)

* Tue Feb 01 2011 Jaroslaw Polok <jaroslaw.polok@cern.ch>
- Kerberos unification, final(?) step

* Wed Dec 15 2010 Matthias Schroder <Matthias.Schroder@cern.ch> - 1-20101215-1.slc6
- use alias name for ocsinventory server

* Tue Dec 14 2010 Matthias Schroder <Matthias.Schroder@cern.ch> - 1-20101214-1.slc6
- add dependency for ncm-ocsagent

* Mon Dec 13 2010 Matthias Schroder <Matthias.Schroder@cern.ch> - 1-20101213-1.slc6
- add data for ncm-ocsagent (component to configure ocsinventory-agent)

* Tue Dec  7 2010 Jaroslaw Polok  <jaroslaw.polok@cern.ch> - 1-20101207-1.slc6
- Nth iteration for slc6

* Tue Oct  4 2010 Jaroslaw Polok  <jaroslaw.polok@cern.ch> - 1-20101004-1.slc5
- added dependency on cern-kerberos-migration

* Tue Apr 21 2009 Jan van Eldik <Jan.van.Eldik@cern.ch> - 0-20090421
- Changing ncm-srvtab to talk to Kerberos master afskrb5m

* Fri Mar 06 2009 Jaroslaw Polok <jaroslaw.polok@cern.ch> - 1-20090127-2.slc5
- small fix to guess_domain.sh script (use busybox if in install environment)

* Tue Jan 27 2009 Jan Iven <jan.iven@cern.ch> - 1-20090127-1.slc5
- disable getting Kerberos4 TGTs in PAM configuration

* Thu Aug 21 2008 Jan Iven <jan.iven@cern.ch> -  1-20080821-5.slc5
- first version for SLC5:
- add ncm-ssh (ssh/sshd config for GSSAPI)
- no longer generate XML via panc, manually edit instead.
- remove ncm-krb4clt
- remove (empty) ncm-security
- add dependency on "lcm"
- postinstall: do not assume we have lcm already installed.
- no longer configure screensaver PAM for afsclt

* Thu Apr 3 2008 Jan Iven <jan.iven@cern.ch> - 0-20080425
- add ncm-chkconfig with nscd and ntpd configured on
- pull in ncm-ntpd (prereq for srvtab), ncm-chkconfig
- add dummy config file for use outside of CERN, do not run lcm
- obsolete zephyr-devel, -server, -X11. may trigger (harmless) errors due to broken post-scripts

* Wed Oct 17 2007 Jan Iven <jan.iven@cern.ch> - 0-20071017
- pine:
  disable GSSAPI, req. for Exchange2007 at CERN (needs ncm-pine >= 1.2.5),
  remove NNTP server config
- set minimum_uid=100 for pam_krb5 to keep system account scans out of KDC logs
- disable zephyr config, no longer used at CERN

* Tue Oct 31 2006 Jan Iven <jan.iven>
- fix PATH to panc

* Tue Oct 24 2006 Jan Iven <jan.iven@cern.ch>
- configure Kerberos ticket lifetime via PAM, only affects SLC3

* Mon Jul 03 2006 Jan Iven  <jan.iven@cern.ch>
- (kerberos) PAM config via ncm-afsclt
- add config for ntpd
- use Make to avoid rebuilds

* Tue May 23 2006 Jan Iven <jan.iven@cern.ch>
- unified .spec for SLC3 and SLC4, new template path

* Tue Feb 14 2006 Jan Iven <jan.iven@cern.ch>
- sendmail: unset local user list, use guessing algorithm
- sendmail: fix smarthost mail.cern -> cern.ch (typo)
- pine: authenticated SMTP by default  (request from J.Chorier)
- pine: ldap name attr to displayName (request from J.Chorier)
- afsclt: change to use http for CellServDB, needs ncm-afsclt>=1.3
- background lcm in %post

* Fri Jan 20 2006 Jan Iven <jan.iven@cern.ch>
- sendmail-smarthost: smtp.cern.ch -> cern.ch, C.Boissat
- krb4: add realm for cern.ch (required for MIT)
- krb5: new config structure, new KDCs/Admin/Password
 
* Sat Oct 15 2004 Jaroslaw Polok <jaroslaw.polok@cern.ch>
- added security.

* Fri Oct 01 2004  Jan Iven <jan.iven@cern.ch>
- added sendmail. Change to "buildrequire" the actual template files from the
  components. Dropped ldapclt. Made the XML result config(noreplace).

* Wed Jun 30 2004  Jan Iven <jan.iven@cern.ch>
- added krb5clt, changed pine setting as per Julian's spec.

* Fri Mar 12 2004 Jaroslaw Polok <jaroslaw.polok@cern.ch>
- fixed pine settings

* Sat Mar 6 2004 Jaroslaw Polok <jaroslaw.polok@cern.ch>
- initial build (weekend was rainy ;-))

